
 // Validations for all wizard steps.
 function checkWizardValidation(wizardTitle){
	
 
 
 // regular expression to match required time format 
   	if(wizardTitle === DATE_TIME_WIZARD){
    	timeZoneValidator();
		$("#dateTimeWizForm").validate({
            rules: {  
                date: {
                    required: true
                },
                time: {
                    required: true,
					isTimeZoneMatch:true
                },
                timeZone: {
                    required: true
                },
                ntpServerText: {
                    required: true
                }
            },
            messages: {
                        date: "Date is required.",
                        time:{ required: "time is required."},
                        timeZone: "timeZone is required.",
                        ntpServerText: "NTP Server Address is required."

            }
        });
        if((!$('#dateTimeWizForm').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
     }
	else if(wizardTitle === HOSTNAME_PASSWORD_WIZARD){
         validator();
         domainNameValidator();
         $("#form_host").validate({
            rules: {  
                host_name: {
                    required: true
                },
                host_domain_name: {
                    required: false,
                    isDomainNameValid: true, // Domain name not mandatory hence required false here.
                   // isDomainFormate: true
                },
                host_root_password: {
                    required: true
                },

                host_confirm_password: {
                    required: true,
                    isPasswordMatch: true,
                }
            },
            messages: {
                        host_name: "Host name is required.",
                        host_domain_name:"Invalid domain name.",
                        host_root_password: "Root password is required.",
                        host_confirm_password:{
                            required: "Confirm password is required."
                    }
            }
        });
        if((!$('#form_host').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
     }else if(wizardTitle === EMAIL_WIZARD){
         
         emailValidator();
         $("#emailQSForm").validate({
            rules: {  
                smtp_server: {
                    required: true
                },
                email_user_name: {
                    required: true
                },
                email_password:{
                    required:true
                },
                email_confirm_pwd:{
                    required:true,
                    isEmailPasswordMatch: true
                }
            },
            messages: {
                        smtp_server: "Smtp server is required.",
                        email_user_name: "Username is required.",
                        email_password: "Password is required.",
                        email_confirm_pwd:{
                          required:"Confirm password is required."  
                        } 
                    }
            });
        if((!$('#emailQSForm').valid())) {
                return false;
        }else{
            return true;
        }
     
         
     }else if(wizardTitle === BACKUP_STORAGE_WIZARD){
        isValidationDone = true;
        return true;
		//backupStoreNameValidator(totalStorageDiskSize);
		//diskSizeValidator(totalStorageDiskSize);
         /*$("#backupStorageWizForm").validate({
            rules: {  
                backup: {
                    required: true,
					isbackupStoreNameMatch:true,
					isDiskSizeMatch:true// ,
					//checkException:true
                }
            },
            messages: {backup: { required:"Backup data store name is required."}}
        });
        if((!$('#backupStorageWizForm').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
        */
	 }else if(wizardTitle === FORUM_ACCOUNT_WIZARD){
		$("#form_forum_account").validate({
            rules: {  
                forum_acccount_email: {
                    required: true
                },
                forum_account_password:{
                    required: true
                }
            },
            messages: {
                forum_acccount_email:"Unitrends forum account is required.",
                forum_account_password:"Password is required."
            }
        });
        if((!$('#form_forum_account').valid())) {
            isValidationDone = false;
                return false;
        }else{
            isValidationDone = true;
            return true;
        }
	 }
    return true; // If All steps are valid then it will return true.
}// checkWizardValidation() >> End

function backupStoreNameValidator(totalStorageDiskSize){
    var backupVal = document.getElementById("backup").value;
	$.validator.addMethod("isbackupStoreNameMatch", function(value, element){ 
	          if(backupVal !== 'Internal' && backupVal !== 'internal')
					return true;
				else
					return false;

	}, "Invalid backup store name");
	
	$.validator.addMethod("isDiskSizeMatch", function(value, element){ 
			 if(totalStorageDiskSize >= 140){
					return true;
				}else{
				   return false;
				}
	}, "Total disk selection should be a minimum size of 140GB");
	
	$.validator.addMethod("checkException", function(value, element){ 
			 if(checkStorageExceptionFlags){
					return true;
				}else{
				   return false;
				}
	}, "Total disk selection should be a minimum size of 140GB");
}
function timeZoneValidator(){
	re = /^\d{1,2}:\d{1,2}:\d{1,2}([ap]m)?$/; 
    var timeFieldVal = document.getElementById("time").value;
	 /* To check root password and Confirm matching or not. */
		$.validator.addMethod("isTimeZoneMatch", function(value, element) { 
				  if(timeFieldVal.match(re))
						return true;
					else
						return false;

		}, "Invalid time format");
}
function domainNameValidator(){
    re = /^[a-z0-9-_]+(\.[a-z0-9-_]+)*\.([a-z]{2,4})$/;
    var domain = $("#domain_name_id").val();
    

     /* To check root password and Confirm matching or not. */
        $.validator.addMethod("isDomainNameValid", function(value, element) { 
                if(domain== undefined || domain== null || domain== ""){
                    return true;
                }
                if(domain.length >63){
                    return false;
                }else{
                    return true;
                }
                if(domain.match(re))
                    return true;
                else
                    return false;

        }, "Invalid domain name");
}

function validator(){
            var rootPsw = $("#host_root_password").val();
            var confimPsw = $("#host_confirm_password").val();
            /* To check root password and Confirm matching or not. */
    $.validator.addMethod("isPasswordMatch", function(value, element) { 
              if(rootPsw === confimPsw)
                      return true;
                else
                    return false;

    }, "Confirm password and password, do not match.");
}
function emailValidator(){
            var passwdEmail = $("#email_password").val();
            var confimPasswdEmail = $("#email_confirm_pwd").val();
            
     $.validator.addMethod("isEmailPasswordMatch", function(value, element) { 
              if(passwdEmail === confimPasswdEmail)
                      return true;
                else
                    return false;

    }, "Confirm password and password, do not match.");
}

