angular.module('configure', ['angulartics', 'angulartics.google.analytics'])

	.controller('ConfigCtrl', ['$scope', '$http', 'Page', '$analytics', function($scope, $http, Page, $analytics) {
								
		Page.setTitle('Configure');

		$scope.tabs = [];
		$scope.currentTabIndex = 0;
		$scope.slugs = ["appliances", "protected-assets", "licensing"];

		$scope.$on('$includeContentLoaded', function() {
		//$scope.initCtrl = function() {
			processConfigurePage(PHD, window, $analytics);
		});

		$scope.licenseLoaded = function() {
			$scope.tabs[2] = new PHD.LicenseTab(1, $("#config-licensing")).init();
			if ($scope.currentTabIndex == 2) {
				$scope.tabs[2].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		$scope.applianceLoaded = function() {
			$scope.tabs[0] = new PHD.ApplianceTab(0, $("#config-appliances")).init();
			if ($scope.currentTabIndex == 0) {
				$scope.tabs[0].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		$scope.assetsLoaded = function() {
			$scope.tabs[1] = new PHD.AssetsTab(1, $("#config-assets")).init();
			if ($scope.currentTabIndex == 1) {
				$scope.tabs[1].activate();
				$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
			}
		};

		// wrap existing jQuery functionality.
		function processConfigurePage(PHD, window, $analytics) {
			var initialTab = $.cookie("initial_tab_config") || 0,
				$emailEditForm,
				$hvRemoveForm = $("#hypervisor-remove-form"),
				$applianceTable = $("#appliance-table"),
				hypervisorFormEdit = false,
				REFRESH_INTERVAL = 6000;

			/*
			 var bdsLookup = {};
			 bdsLookup[BDS_TYPE_BACKUP] = "backup";
			 bdsLookup[BDS_TYPE_REPLICATION] = "mount";
			 bdsLookup[BDS_TYPE_CLOUD_CACHE] = "cloud";
			 bdsLookup[BDS_TYPE_IR_CACHE] = "ircache";
			 bdsLookup[BDS_TYPE_ARCHIVE] = "archive";
			 bdsLookup[BDS_TYPE_SYNC] = "sync";
			 */

			/*var GlobalTab = function (index, $panel) {
				this.index = index;
				this.$panel = $panel;
			};

			GlobalTab.prototype.init = function () {
				$(".btn-edit-auto-updates").on("click", function (event) {
					event.preventDefault();
					var url = $(this).attr("href");

					PHD.wizard(url, "edit-auto-updates-config", {
						title: gettext("Edit Auto Update Settings"),
						helpArticle: PHD.App.getHelpLink("autoupdates", true),
						width: 500,
						height: 'auto'
					});
				});

				$(document).on("autoupdatesformsave", this.updateAutoUpdates);

				 $("#id_enable_auto_updates").on("click", function() {
					 var $editForm = $("#auto-updates-form");
					 $.ajax($editForm.attr("action"), {
					 	async: false,
					 	data: $editForm.serialize(),
					 	dataType: "json",
					 	type: 'POST',
					 	success: function(data) {
					 		if(data.result[0].code != AJAX_RESULT_SUCCESS) {
					 			PHD.throwError(data);
					 		}
					 	}
					 });
				 });

				$(".btn-upload-hotfix").on("click", function (event) {
					event.preventDefault();
					var url = $(this).attr("href");

					PHD.wizard(url, "upload-hotfix-config", {
						title: gettext("Upload Hotfix File"),
						helpArticle: PHD.App.getHelpLink("uploadhotfix", true),
						width: 500,
						height: 225
					});
				});

				$(".btn-edit-email").on("click", function (event) {
					event.preventDefault();
					var url = $(this).attr("href");

					PHD.wizard(url, "edit-email-config", {
						title: gettext("Edit Email SMTP Settings"),
						helpArticle: PHD.App.getHelpLink("emailsettings", true),
						width: 900,
						height: 720
					});
				});

				$(document).on("emailformsave", this.updateEmail);

				$(".btn-edit-flr-creds").on("click", function (event) {
					event.preventDefault();
					var url = $(this).attr("href");

					PHD.wizard(url, "edit-cifs-creds-config", {
						title: gettext("Edit File Recovery Credentials"),
						helpArticle: PHD.App.getHelpLink("flrcredentials", true),
						width: 400,
						height: 350
					});
				});

				$(document).on("cifscredsformsave", this.updateCifsCreds);

				$(".btn-edit-advanced-settings").on("click", function (event) {
					event.preventDefault();
					var url = $(this).attr("href");

					PHD.wizard(url, "edit-advanced-settings", {
						title: gettext("Edit Advanced Settings"),
						helpArticle: PHD.App.getHelpLink("advancedsettings", true),
						width: 520,
						height: 500
					});
				});

				$(document).on("advancedsettingssave", this.updateAdvancedSettings);

				return this;
			};

			GlobalTab.prototype.updateAutoUpdates = function (event, data) {
				$("#auto-updates-text").text(data.set_or_not_set);
			};

			GlobalTab.prototype.updateEmail = function (event, data) {
				$("#hv-smtp-server").text(data.email_host);
				$("#hv-smtp-port").text(data.email_port);
				$("#hv-smtp-security").text(data.email_encryption);
				$("#hv-smtp-send-email").text(data.send_email ? gettext("Enabled") : gettext("Disabled"));
			};

			GlobalTab.prototype.updateCifsCreds = function (event, data) {
				$("#flr-creds-password").text(data.set_or_not_set);
			};

			GlobalTab.prototype.updateAdvancedSettings = function (event, data) {
				$("#connectors-method").text(data.connector_method);
				$("#orphan-retention").text(data.orphan_retention);
			};

			GlobalTab.prototype.activate = function () {
				return this;
			};

			GlobalTab.prototype.deactivate = function () {
				return this;
			};
			*/

			function initTabs() {
				$scope.tabs[0] = {}; //new PHD.ApplianceTab(0, $(".ui-tabs-panel").eq(0)).init();
				$scope.tabs[1] = {}; // new PHD.ApplianceTab(1, $(".ui-tabs-panel").eq(1)).init();
				$scope.tabs[2] = {}; //new PHD.LicenseTab(1, $(".ui-tabs-panel").eq(2)).init();
				//tabs[3] = new GlobalTab(1, $(".ui-tabs-panel").eq(3)).init();

				//$scope.tabs[currentTabIndex].activate();
				//$(document).trigger("tabchange", "config" + slugs[currentTabIndex]);
			}

			function initForm() {
				/**
				 * Return true if the field value matches the given format RegExp
				 *
				 * @example jQuery.validator.methods.pattern("AR1004",element,/^AR\d{4}$/)
				 * @result true
				 *
				 * @example jQuery.validator.methods.pattern("BR1004",element,/^AR\d{4}$/)
				 * @result false
				 *
				 * @name jQuery.validator.methods.pattern
				 * @type Boolean
				 * @cat Plugins/Validate/Methods
				 */
				$.validator.addMethod("pattern", function (value, element, param) {
					if (this.optional(element)) {
						return true;
					}
					if (typeof param === 'string') {
						param = new RegExp('^(?:' + param + ')$');
					}
					return param.test(value);
				}, gettext("Invalid format."));
			}

			/*
			 *   DOM Ready Function
			 */
			$(function () {
				// Initialize form validation and event handlers
				initForm();

				// Quick and dirty way to change what tab opens by default via URL
				if (!isNaN(PHD.util.getHashInt())) {
					initialTab = PHD.util.getHashInt();
				}

				// Initialize the tabs
				$('.tabs-wrapper').tabs({
					active: initialTab,
					create: function (event, ui) {
						$scope.currentTabIndex = ui.tab.index();
						initTabs();
					},
					activate: function (event, ui) {
						$scope.currentTabIndex = ui.newTab.index();
						$.cookie("initial_tab_config", $scope.currentTabIndex, {expires: 365, path: '/'});
						$scope.tabs[ui.oldTab.index()].deactivate();
						$scope.tabs[$scope.currentTabIndex].activate();
						$(document).trigger("tabchange", "config" + $scope.slugs[$scope.currentTabIndex]);
					}
				});
			});

		}

	}]
)