/* ActiveJob Widget Contorller */
angular.module('activeJobWidgetModule',['dynamicdashboardapp','ui.dashboard'])
.controller('ActiveJobsDashCtrl', function ($scope,$rootScope, $http){

		$scope.refreshKey="dash_active_job_refresh";
        $scope.widgetName="Active Job";
		$scope.backupTimer=3000;
        $scope.dropdownvalue="0";
		var $widget = $("#widget-active-jobs"),
		$prefTrigger = $widget.find(".preference-trigger"),
		$jobTable = $("#dashboard-jobs"),
		$widgetLinks = $("#active-job-links"),
		ajaxActive = false,
		activeJobType = $widgetLinks.find(".selected").data("job-type"),
		refreshRate = refreshRates.dash_active_job_refresh,
		namespace = "activejobswidget",
		JobTable, UserPreference, Timer;
		
		var dtOptions = {
                select: false,
                multiselect: false,
                className: "active-jobs",
                cellClasses: ["long-text truncate", "long-text truncate", null, null, null, null],
                placeholder: gettext("There are no active jobs")
        };
		
		/* lmc
             */
		var cellFormatter = {
			name: function (value, row) {
			  return '<span class="truncates item-name" title="' + value + '"><a href="#/jobs/?select=' + row.id + '#0">' + value + '</a></span>';
			}
		}

     /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'ACTIVE JOBS'){
            $scope.toggleModal();
			$scope.widgetID='ID'+index;
			$scope.dropdownvalue = $rootScope.backupTimer /1000;
			$("[id='id_active jobRefresh']").val($rootScope.listOfTimer[1]/1000);
				event.defaultPrevented = true;
        }
    });
	
	/* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'ACTIVE JOBS'){
		$scope.getActiveJobData(true,true);
		event.defaultPrevented = true;
		    
        }
    });
	
	/*Event listener on clcik of activeJobs links*/
	    $widgetLinks.on("click", "a", function (event) {
                event.preventDefault();
                // Timer.stop();
                var $but = $(this).parent();
                if (ajaxActive || $but.is(".selected")) {
                    return false;
                }

                $widgetLinks.children("li").removeClass("selected");
                activeJobType = $but.addClass("selected").data("job-type");
                // lmc
                activeJobType = activeJobType.toLowerCase();
                $scope.getActiveJobData(false, true);
        });
	 
		$rootScope.getActiveJobData = function(init, change) {
			var url = '/api/jobs/active/' + activeJobType + '/';
			var resp;

			ajaxActive = true;

			if (init === true) {
				JobTable = PHD.DataTable($jobTable, dtOptions).registerFormatters(cellFormatter);
				resp = PHD.Ajax.get(url);
			} else {
				resp = PHD.Ajax.get(url);
			}
			 resp.done(function (data) {
			 	if (init === true || change === true) {
					JobTable.load(data.data);
				} else {
					JobTable.update(data.data, true);
				}
                $jobTable.scrollTable({"height": ".widget-content"});
				ajaxActive = false;

			});
    }

	/*to Get User prefrence*/
	$scope.userPrefernce = function(){
	       $rootScope.manualRefreshControl($rootScope.listOfTimer[1]/1000,$scope.widgetName);
	}
	
	
	if ($scope.user.loggedIn) {
		$scope.userPrefernce();
		$scope.getActiveJobData(true,true);
    }
	
	 $(document)
		.on("login", function (event) {
			$scope.getActiveJobData(true,true);
			stopAll();
		})
		.on("logout", function (event) {
			stopAll();
		})
		.on("uinav.dashboard", function (event) {
		})
		.on("uinav.protect", function (event) {
			stopAll();
		})
		.on("uinav.recover", function (event) {
			stopAll();
		})
		.on("uinav.jobs", function (event) {
			stopAll();
		})
		.on("uinav.configure", function (event) {
			stopAll();
		})
		.on("uinav.reports", function (event) {
			stopAll();
		})

	function stopAll() {
	    clearInterval($rootScope.listOfTimerFunction[1]);
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
	} 

});


