(function($, PHD, window, undefined) {

    var $logTables = $(".log-table"),
        headerHeight = $("#job-log h3").eq(0).height();

    function resizeTables(event) {
        this.each(function() {
            $(this).adjustTableHeight(($(this).getAvailableVerticalSpace("article")/4) - (headerHeight*2));
            $(this).adjustTableWidth();
        });
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        $logTables.each(function() {
            $(this)
                .scrollTable({"height": ($(this).getAvailableVerticalSpace("article")/4) - (headerHeight*2)})
                .sortTable();
        });

        $(window)
            .off("resize.irlog")
            .on("resize.irlog", PHD.util.debounce($.proxy(resizeTables, $logTables)));
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
