
var DateTimeHandler = {};

DateTimeHandler.convertTimeToAPI = function(format, str) {
    var hours = Number(str.match(/^(\d+)/)[1]);
    var minutes = Number(str.match(/:(\d+)/)[1]);
    var AMPM = str.match(/\s?([AaPp][Mm]?)$/)[1];

    var pm = ['P', 'p', 'PM', 'pM', 'pm', 'Pm'];
    var am = ['A', 'a', 'AM', 'aM', 'am', 'Am'];

    if (pm.indexOf(AMPM) >= 0 && hours < 12) hours = hours + 12;
    if (am.indexOf(AMPM) >= 0 && hours == 12) hours = hours - 12;

    var sHours = hours.toString();
    var sMinutes = minutes.toString();
    if (hours < 10) sHours = "0" + sHours;
    if (minutes < 10) sMinutes = "0" + sMinutes;

    if (format == '0000') {
        return (sHours + sMinutes);
    } else if (format == '00:00') {
        return (sHours + ":" + sMinutes);
    } else if (format == '00:00:00') {
        return (sHours + ":" + sMinutes + ':00');
    } else {
        return false;
    }
};

DateTimeHandler.convertTimeFromAPI = function(str) {
    var ret = "";
    if (str != null) {
        ret = str.replace(/ pm/g,"PM").replace(/ am/g, "AM");
    }
    return ret;
};