angular.module('alertWidgetModule', [])
		.directive('userPreference', function(){
				 return{
		restrict: 'E',
		scope:{
		  show: '='
		},
		replace: true, /* Replace with the template below */
		transclude: true, /*we want to insert custom content inside the directive*/
		link: function(scope, element, attrs){
		  scope.dialogStyle={};
		  if (attrs.width)
			scope.dialogStyle.width=attrs.width;
		  if (attrs.height)
			scope.dialogStyle.height=attrs.height;
		  scope.hideModal=function(){
			scope.show=false;
		  };
		},
		template: "<div class='ng-modal' ng-show='show'><div class='ng-alertUserprefrence-dialog' ng-style='dialogStyle'><div class='ng-alertUserprefrence-dialog-content' ng-transclude></div></div></div>"
		};
	})
    .controller('AlertWidgetContorller', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http) {

        $scope.initCtrl = function() {
            processAlertsWidget(PHD, window);
        }

		$scope.widgetName="Alerts";
		
		
		$scope.openDailog = false;
	    $scope.toggleModal = function() {
			
		$scope.openDailog = !$scope.openDailog;
	};
		
			
        //(function($, PHD, window, undefined) {
        function processAlertsWidget(PHD, window) {
		        var $widget = $("#widget-alerts-dailog"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $btnDismissAll = $widget.find(".btn-dismiss-all-alert"),
                $alertsTable = $("#dashboard-alerts-dailog"),
                $alertsIcon = $("h1.alerts"),
                $alertDetail = $(),
                timestamp = 0,
                refreshRate = refreshRates.dash_alert_refresh,
                namespace = "alertswidget",
                AlertsTable, UserPreference, Timer;
				$rootScope.timestamp=0;
				$scope.clickCount=0;
			    var severityArray=[];
				var alertIDArray=[];
				 
		 
		  
            var dataTableOptions = {
                select: true,
                multiselect: false,
                className: "alert",
                cellClasses: ["alert-severity", "alert-sname", "alert-time", "alert-message"],
                placeholder: gettext("There are no unresolved alerts")
            };
			
			$scope.closeDailog = function()
			{
				 var scope = $("[ng-controller=GlobalCtrl]").scope();
				 scope.toggleModal();
			}
			
			/* function will fixed the width of header and data rows of JQuery DataTable
		     */
			function setHeaderWidth()
			{   				
				$('#dashboard-alerts-dailog .severity').css({"width": "44px" , "max-width": "44px","min-width": "44px"}); 
				$('#dashboard-alerts-dailog .appliance').css({"width": "118px" ,"max-width": "118px","min-width": "118px"}); 
				$('#dashboard-alerts-dailog .time').css({"width": "151px" ,"max-width": "151px","min-width": "151px"}); 
				$('#dashboard-alerts-dailog .message').css({"width": "453px" ,"max-width": "453px","min-width": "107px"}); 
				$('#dashboard-alerts-dailog .dismiss_row').css({"width": "31px" ,"max-width": "31px","min-width": "31px"}); 
				$('#dashboard-alerts-dailog .close_row').css({"width": "31px" ,"max-width": "31px","min-width": "31px"}); 
				$('#dashboard-alerts-dailog .alert-sname').css({"width": "118px" , "max-width": "118px","min-width": "118px"}); 
				$('#dashboard-alerts-dailog .alert-severity').css({"width": "44px" , "max-width": "44px","min-width": "44px"});  
				$('#dashboard-alerts-dailog .alert-time').css({"width": "151px" , "max-width": "151px","min-width": "151px"});  
				$('#dashboard-alerts-dailog .alert-message').css({"width": "480px" ,"max-width": "480px","min-width": "480px"});
		
			}
			/* function will decide the highest priority of alert present in 
			 * the data and change alert background color based on that
			 * Critical : Red    (HexCode: "#bc3d41")
			 * Warning  : Yellow (HexCode: "#e8e460")
			 * Notice   : Green  (HexCode: "#80bc3d")
		     */
			 function setColorOfAlert()
			 {  
				 if (severityArray.indexOf("critical") != -1)
					{
						
					$("#app-header .alert-count_1").css("background-color", "#bc3d41");
					
					}
				 else if (severityArray.indexOf("warning") != -1)
					{
						
						$("#app-header .alert-count_1").css("background-color", "#e8e460");
					}
				 else
					{
						
						$("#app-header .alert-count_1").css("background-color", "#80bc3d");
					}
						
					
			 }
			 
			/* function equivalent to PHD.updateAlerts(true, data.length) in main.js
			   instead of data.length we are taking up entire data to 
				to store type of Alert(i.e.Critical,Warning and Notice) 
				and id of Alert.
			 */
	  
			$scope.changeAlertCount = function(fromFunction,data)
			{  
			    if (fromFunction =='fromUpdate') 
				{
					/*pushing severity and ids of Alerts in respective Arrays*/
					for (var i = 0 ; i < data.length ; i++)
					{
						severityArray[i]=data[i].severity;
						alertIDArray[i]=data[i].id;
						
					}
						setColorOfAlert();
				
					/* set the AlertCount based on number of alerts*/
			        $("#app-header .alert-count_1").text(data.length);
				  
				}
			  else
			  {
				 /* called from dismiss-all alerts method
					*color of background should be green
					*alert count set to 0
 				 */
				   severityArray=[];
				   alertIDArray=[];
				  $("#app-header .alert-count_1").css("background-color", "#80bc3d");
				  $("#app-header .alert-count_1").text(0);
			  }
			  
			
			}
			
			/*
			* equivalent to PHD.fetchStats() of mainJS;
			 *decreases the existing count of alert by one
			 *also mark the 
			*/
			
			$scope.fetchStats = function(alerID)
			{
				
				
				var currentvalue = parseInt($("#app-header .alert-count_1").text());
				var updatedValue = currentvalue - 1;
				
				if (updatedValue == 0)
				{
						 severityArray=[];
						 alertIDArray=[];
						$("#app-header .alert-count_1").css("background-color", "#80bc3d");
				}
				else{
					var index = alertIDArray.indexOf(alerID);
					severityArray[index]="deleted";
					alertIDArray[index]="deleted";
					setColorOfAlert();
				}
				$("#app-header .alert-count_1").text(updatedValue);
			}
			
			/*template used for pop-over*/
            var alertTmpl = _.template(
                '<p><strong><%= message %></strong></p>' +
                '<% if(typeof(insert_date) !== "undefined") { %><p><label>Date:</label><span><%= moment(insert_date).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(created) !== "undefined") { %><p><label>Date:</label><span><%= moment(created).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(updated) !== "undefined") { %><p><label>Updated:</label><span><%= moment(updated).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(alert_type) !== "undefined") { %><p><label>Alert Type:</label><span><%= alert_type %></span></p><% } %>' +
                '<% if(typeof(source_name) !== "undefined") { %><p><label>Alert Source:</label><span><%= source_name %></span></p><% } %>' +
                '<% if(typeof(sname) !== "undefined") { %><p><label>Appliance:</label><span><%= sname %></span></p><% } %>' +
                '<% if(typeof(management) !== "undefined") { %><p><label>Environment:</label><span><%= management.data.ip %></span></p><% } %>' +
                '<% if(typeof(layer) !== "undefined") { %><p><label>Appliance:</label><span><%= layer.data.ip %></span></p><% } %>' +
                '<% if(typeof(inventory) !== "undefined") { %><p><label>Inventory:</label><span><%= inventory.data.name %></span></p><% } %>' +
                '<p><a href="<%= kburl %>" class="btn-alert-kb text-success" style="text-transform:capitalize; color: #80bc3d;" target="phdvbhelp"><i class="icon-bookalt" style="color:#80bc3d;" ></i>Knowledge Base</a>' +
                '<a href="/api/alerts/<%= id %>" class="btn-dismiss-alert text-critical" style="text-transform:capitalize; color:  #bc3d41;"><i class="icon-delete" style="color:#bc3d41;"></i> Dismiss Alert</a></p>'
            );

            var cellFormatter = {
                /*alert_type: function (value, row) {

                    var type = row.alert_type;
                    var iconclass = "icon-";


                    switch (type) {
                        case ALERT_TYPE_UNKNOWN:
                            iconclass += "questionsign";
                            break;
                        case ALERT_TYPE_LICENSE_EXPIRED:
                        case ALERT_TYPE_LICENSE_INVALID:
                            iconclass += "exclamationsign";
                            break;
                        case ALERT_TYPE_UPDATES_AVAILABLE:
                        case ALERT_TYPE_UPDATE_COMPLETE:
                            iconclass += "upload";
                            break;
                        case ALERT_TYPE_EMAIL_ERROR:
                        case ALERT_TYPE_SMTP_NOT_CONFIGURED:
                            iconclass += "emailtrace";
                            break;
                        default:
                            iconclass += "warningsign";
                    }

                    return '<i class="' + iconclass + ' alert-type-icon" title="' + value + '"></i>';
                },
                */
                severity: function (value, row) {

                    var alert_severity = row.severity;
                    var iconclass = "icon-";

                    switch (alert_severity) {
                        case ALERT_SEVERITY_NOTICE:
                            iconclass += "upload";
                            break;
                        case ALERT_SEVERITY_CRITICAL:
                            iconclass += "exclamationsign";
                            break;
                        case ALERT_SEVERITY_WARNING:
                        default:
                            iconclass += "warningsign";
                            break;
                    }

                    return '<i class="' + iconclass + ' severity-icon" title="' + alert_severity + '"></i>';
                },
                insert_date: function (value) {
                    return moment(value).format("MM/DD/YYYY hh:mm a");
                },
                created: function (value) {
                    return moment(value).format("MM/DD/YYYY hh:mm a");
                }
            };
				/*Function to update the Alert widget*/
            function updateWidgetAlert(init) {
             var scope = $("[ng-controller=GlobalCtrl]").scope();
                if (!scope.user.loggedIn) {
                    
                    return;
                }
				
                var url = API_DIR + '/alerts/open/?timestamp=' + $rootScope.timestamp;
		      
                var resp = PHD.Ajax.get(url);
				
                if (init === true) {
                    AlertsTable = PHD.DataTable($alertsTable, dataTableOptions).registerFormatters(cellFormatter);
					 $alertsTable.sortTable();
					
                }

                resp.done(function (data) {
                    $rootScope.timestamp = data.timestamp;
			  
                    if (init === true) {
					
                        AlertsTable.load(data.data);
						$scope.changeAlertCount('fromUpdate',data.data);
						
						
                    } else {
						 if (data.data.length) {
                            //PHD.updateAlerts(true, data.length);
						
							if ( typeof(init) == 'undefined')
							{
							$scope.changeAlertCount('fromUpdate',data.data);
											
                            AlertsTable.update(data.data);
							}
							
                        }
                    }

                    $alertsTable
                         .scrollTable({"height": 150,"resize": false});
						  $alertsTable.sortTable();
						setHeaderWidth();
                   
                });
            }

            $alertsTable
                .on("updatefinished", function (event, newRows) {
                    if (newRows) {
                        $alertsTable.sortTable();
                        $alertsIcon.animate({opacity: 0}, 500, function () {
                            $alertsIcon.animate({opacity: 1}, 500);
                        });
                    }
                })
                .on("rowselect", "tr", function (event, dbid, $row, DataTable, DataRow) {
				    DataTable.deselect();
                    if ($row.data('popover')) {
                        $row.data('popover').toggle();
                    } else {
                        var data = DataRow.data,
                            html;

                        data.kburl = alertURL(alert.source_id);
                        html = alertTmpl(data);

                        $alertDetail = $("<div>");
                        $alertDetail.html(html)
                            .on("click", ".btn-dismiss-alert", function (e) {
                                e.preventDefault();
                                if (data.severity == ALERT_SEVERITY_CRITICAL) {
                                    if ($row.data('popover')) {
                                        $row.data('popover').toggle();
                                    }
                                    PHD.confirmDialog("<p>" + gettext("This alert is critical.  Are you sure you want to dismiss it?") + "</p>", {
                                        title: gettext("Confirm Alert Dismissal")
                                    })
                                        .done(function() {
                                            doDelete($row, data, DataTable, true);
                                        }
                                    )
                                } else {
                                    doDelete($row, data, DataTable, true);
                                }
                            })
                            .popover({
                                anchor: $row,
                                appendTo: $widget,
                                popoverClass: 'alert-detail',
                                position: {
                                    my: "right top",
                                    at: "right top"
                                }
                            });

                        $row.data('popover').open();
                    }
                });

            function doDelete($row, data, DataTable, fetch) {
	            var sid = data.system_id;
                var id = data.id;
                var url = "/api/alerts/" + id + '/?sid=' + sid;
                var doFetch = fetch || false;
				
				
				
                PHD.Ajax
                    .delete(url)
                    .done(function (data) {
                        if ($row != null && $row.data('popover')) {
                            $row.data('popover').destroy();
                        }
                        DataTable.deleteRow(id);
                        if (doFetch) {
                            
						   $scope.fetchStats(id);
                        }
                    });
            }

            function alertURL(type) {
                var url = $rootScope.isCE ? CE_KNOWLEDGE_BASE_URL : KNOWLEDGE_BASE_URL,
                    article = ALERT_HELP_LINKS.hasOwnProperty(type) ? ALERT_HELP_LINKS[type] : ALERT_HELP_LINKS[ALERT_TYPE_UNKNOWN];

                // -- need consolidation of this!! lmc return url + article;
                return url;
            }


            function handleDismissAll(event) {
                PHD.confirmDialog("<p>" + gettext("Please take care when dismissing alerts, especially if some are critical.") + '</p>' +
									"<p>" + gettext("Dismissing does not fix the condition that caused the alert. An alert that has been dismissed \
									may display again if the alert condition has not been resolved.") + '</p>' +
                                  '<p>' + gettext("Are you sure you would like to dismiss all alerts?") + '</p>', {
                    title: gettext("Confirm Alert Dismissal")
                })
                    .done(function() {
						
						if (AlertsTable != 'undefined')
						{
                        AlertsTable.data.forEach(function(alert, i, array) {
						doDelete(null, alert, AlertsTable, false);
                        });}
						    $scope.changeAlertCount('fromDelete');
							updateWidgetAlert();
						
                    });
            }
			
			
	/*function to refresh AlertData
	  *it will call updateWidgetAlert to update the 
 	  *updateWidgetAlert
	*/		
		$rootScope.getAlertsRefereshData = function()
		{   
			updateWidgetAlert();
		}
					/* UserPreference = PHD.UserPreference($prefTrigger, {
                name: gettext("Alerts Widget"),
                namespace: "alertswidget",
                key: "dash_alert_refresh",
                refresh_name: "Alert refresh",
                defaultValue: refreshRate
            });

		/* to Get User preference of refresh rate for Alert 
		*  and also making call to manualRefreshControl method to show/hide refresh icon
		*/
		$scope.userPrefernce = function(){
				
				 $rootScope.manualRefreshControl($rootScope.listOfTimer[$rootScope.listOfWidgetName.indexOf("Alerts")] /1000,$scope.widgetName);
				 
		}				
		

          
			$scope.$on("loged-in", function(event) {
				updateWidgetAlert(true);
				$scope.userPrefernce();
				
			});
	
	
         /*Event will be triggered every time alert is clicked*/
	
         function clickEventofLI(event){
			 /*fetching the Global controller scope  */
		   var scope = $("[ng-controller=GlobalCtrl]").scope();
		   	if (scope.modalShown == true)
				{
						// updateWidgetAlert('No refresh');
						  
						   $scope.clickCount = $scope.clickCount + 1; 
						/*We need to refresh for the very first time click of Alert link*/
					 if ($scope.clickCount == 1 )
						{	
							//updateWidgetAlert('No refresh');
							
						} 
				}
		  else
				{
					$scope.clickCount=0;
				} 
				
		  } 
        function closeDailog()    
            {
                  var scope = $("[ng-controller=GlobalCtrl]").scope();
		   	      if (scope.modalShown == true)
                    {
                        scope.toggleModal();
                    }
            }
		  
            /*
             *   DOM Ready Function
             */
			 
			$(document)
                .on("login", function (event) {
                    stopAll();
                })
                .on("logout", function (event) {
                
                })
                .on("uinav.dashboard", function (event) {

                })
                .on("uinav.protect", function (event) {
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    stopAll();
                });

            function stopAll() {
               
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
               
                delete $(document);
            }			 
			
			function startAlertTimer(event){
                   closeDailog();
                   $rootScope.manualRefreshControl($rootScope.listOfTimer[$rootScope.listOfWidgetName.indexOf("Alerts")] /1000,$scope.widgetName);
            }
			
            $(function () {
				/*Adding couple of event listener 
				* 1) handleDismissAll - Event to delete all alert
				* 2) clickEventofLI - on alerts' click
				*/
				
                   $btnDismissAll.on("click", handleDismissAll);
				   $('.alerts-menu').on("click", clickEventofLI);
				   $('#nav-dashboard').on("click", startAlertTimer);
                   $('#nav-protect').on("click", closeDailog);
                   $('#nav-recover').on("click", closeDailog);
                   $('#nav-jobs').on("click", closeDailog);
                   $('#nav-reports').on("click", closeDailog);
                   $('#nav-configure').on("click", closeDailog);
               
                
                
                
                });

        }
        //})(jQuery, window.PHD || (window.PHD = {}), window);
    }]);
