
/********************** Validation for Add Forum Account *********************/
function isAddFormValid(){
    addAccemailValidator();
    isAddEmailCorrectFormat();
     $("#form-add-account").validate({
        rules: {  
            txtAcEmailname: {
                required: true,
                isAddEmailValid:true
            },
            add_acc_password_name: {
                required: true
            },
            confirm_acc_password_name: {
                required: true,
                isPasswordMatch:true
            }

        },
        messages: {
                txtAcEmailname: {
                    required:"Email is required."
                },
                add_acc_password_name:"Password is required.",
                confirm_acc_password_name:{
                    required: "Confirm password is required."
            }
        }
    });
    if((!$('#form-add-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function addAccemailValidator(){
            var addAccountPsw = $("#add_acc_password").val();
            var confimPasswdEmail = $("#confirm_acc_password").val();
       $.validator.addMethod("isPasswordMatch", function(value, element) { 
              if(addAccountPsw === confimPasswdEmail)
                      return true;
                else
                    return false;

    }, "Confirm password and password, do not match.");
}
/********************** Create Forum Account *********************/
function isCreateForumFormValid(){
    createAccemailValidator();
    isCreateEmailCorrectFormat();
     $("#form-create-forum-account").validate({
        rules: {  
            txtNickName: {
                required: true
            },
            txtFirstName: {
                required: true
            },
             txtLastName: {
                required: true
            },
             txtEmail: {
                required: true,
                 isCreateEmailValid:true
            },
             create_forum_password: {
                required: true
            },
            create_confirm_password: {
                required: true,
                isCreatePasswordMatch:true
            }

        },
        messages: {
                txtNickName: "Nickname is required.",
                txtFirstName:"First name is required.",
                txtLastName: "Last name is required.",
                txtEmail:{
                    required:"Email is required."
                },
                create_forum_password:"Password is required.",
            
                create_confirm_password:{
                    required: "Confirm password is required."
            }
        }
    });
    if((!$('#form-create-forum-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function createAccemailValidator(){
            var createAccountPsw = $("#create_forum_password").val();
            var changeConfimPasswdEmail = $("#create_confirm_password").val();
       $.validator.addMethod("isCreatePasswordMatch", function(value, element) { 
              if(createAccountPsw === changeConfimPasswdEmail)
                      return true;
                else
                    return false;

    }, "Confirm password and password, do not match.");
}

/********************** Change Forum Account *********************/
function isChangeFormValid(){
    
    changeAccemailValidator();
    isChangeEmailCorrectFormat();
     $("#form-create-account").validate({
        rules: {  
            txtchangeAccEmail: {
                required: true,
                isEmailValid: true
            },
            change_acc_password: {
                required: true
            },
            change_confirm_password: {
                required: true,
                isChangePasswordMatch:true
            }

        },
        messages: {
                txtchangeAccEmail: {
                    required:"Email is required."
                },
                change_acc_password:"Password is required.",
                change_confirm_password:{
                    required: "Confirm password is required."
            }
        }
    });
    if((!$('#form-create-account').valid())) {
        return false;
    }else{
        return true;
    }
 }

function changeAccemailValidator(){
            var changeAccountPsw = $("#change_acc_password").val();
            var ChangeConfimPasswdEmail = $("#change_confirm_password").val();
       $.validator.addMethod("isChangePasswordMatch", function(value, element) { 
              if(changeAccountPsw === ChangeConfimPasswdEmail)
                      return true;
                else
                    return false;

    }, "Confirm password and password, do not match.");
}
/*************************** Refresh dashbord wizards **********************/
function refreshPage(){
    var currentPage = angular.element(document.getElementById("app-main"));

            var injector = currentPage.injector();
            var route = injector.get('$route');
            route.reload();
}


function isCreateEmailCorrectFormat(){
    
     $.validator.addMethod("isCreateEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var createEmail =  $("#txtEmailId").val();
            if (testEmail.test(createEmail))
                return true;
            else 
                return false;
          }, "Please enter a valid email address.");
}

function isChangeEmailCorrectFormat(){
    
     $.validator.addMethod("isEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var email =  $("#txtchangeAccEmail").val();
            if (testEmail.test(email))
                return true;
            else 
                return false;
          }, "Please enter a valid email address.");
}

function isAddEmailCorrectFormat(){
    
     $.validator.addMethod("isAddEmailValid", function(value, element) { 
        var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
         var addEmail =  $("#txtAcEmailId").val();
            if (testEmail.test(addEmail))
                return true;
            else 
                return false;
          }, "Please enter a valid email address.");
}