angular.module('protect', ['angulartics', 'angulartics.google.analytics'])

    .controller('ProtectCtrl', ['$scope', '$rootScope', '$http', 'Page','$compile', '$analytics', function($scope, $rootScope, $http, Page, $compile, $analytics) {
        Page.setTitle('Protect');

        $scope.$on('$viewContentLoaded', function() {
            processProtectPage(PHD, window, $scope, $rootScope, $compile, $analytics);
        });

        $scope.loadStatus = function(sid, bid, date, name, type) {
            $(".job-inventory-result").hide();

            PHD.appliance_sid = sid;
            if (type == 'Backups') {
                console.log("in load backup detail status");
                backup_ids = bid;
                PHD.wizard("app/inventory/details/status.html", "view-status", {
                    title: gettext(name + " Backup Status: " + date),
                    dialogClass: "standalone",
                    height: 500,
                    helpArticle: PHD.App.getHelpLink("backup", true)
                });
            } else {
                console.log("in load backup copy detail status");
                copy_ids = bid;
                PHD.wizard("app/inventory/backup-copy-details/status.html", "view-status", {
                    title: gettext(name + " Backup Copy Status: " + date),
                    dialogClass: "standalone",
                    height: 390,
                    helpArticle: PHD.App.getHelpLink("backup", true)
                });
            }
        }

    }]);
