
var JOB_TYPE_UNKNOWN=0,
    JOB_TYPE_BACKUP=1,
    JOB_TYPE_RESTORE=2,
    JOB_TYPE_ROLLBACK=3,
    JOB_TYPE_REPLICATION=4,
    JOB_TYPE_NCDP=5,
    JOB_TYPE_INSTANT_RESTORE=6,
    JOB_TYPE_LINK=7,
    JOB_TYPE_DELETE=8,
    JOB_TYPE_BDSIO=9,
    JOB_TYPE_VERIFY=10,
    JOB_TYPE_ORPHAN_HUNT=11,
    JOB_TYPE_SNAPSHOT_HUNT=12,
    JOB_TYPE_HYPERVISOR=13,
    JOB_TYPE_BACKUP_DISK=14,
    JOB_TYPE_ARCHIVE=16,
    JOB_TYPE_IR_START=18,
    JOB_TYPE_IR_SEED=19,
    JOB_TYPE_IR_MOTION=20,
    JOB_TYPE_IR_END=21,
    JOB_TYPE_ARCHIVE_DISK=17,
    JOB_TYPE_RESTORE_DISK=15,

    RECOVERY_JOB_TYPE_STANDARD=1,
    RECOVERY_JOB_TYPE_ROLLBACK=0,
    RECOVERY_JOB_TYPE_INSTANT=2,

    // Password length
    MAX_PASSWORD_LENGTH = 64,

    STORAGE_INTERNAL = 0,
    STORAGE_ISCSI = 1,
    STORAGE_FC = 2,
    STORAGE_NAS = 4,
    STORAGE_ADDED_INTERNAL = 5,


    // lmc - completed job result
    /*JOB_STATUS_UNKNOWN=0,
    JOB_STATUS_SUCCESS=1,
    JOB_STATUS_WARNING=2,
    JOB_STATUS_ERROR=3,
    JOB_STATUS_CRITICAL=4,
    JOB_STATUS_PARTIAL_SUCCESS=5,
    JOB_STATUS_NONE=6,
    */

    // lmc - "active" job status
    /*JOB_STATE_PENDING=-1,
    JOB_STATE_UNKNOWN=0,
    JOB_STATE_QUEUED=1,
    JOB_STATE_PAUSED=2,
    JOB_STATE_RUNNING=3,
    JOB_STATE_PAUSING=4,
    JOB_STATE_CANCELING=5,
    JOB_STATE_FINISHED=6,
    JOB_STATE_CANCELED=7,
    JOB_STATE_IDLE=8,
    */

    /*JOB_SECTION_ALL=0,
    JOB_SECTION_DETAILS=1,
    JOB_SECTION_LOG=2,
    */

    HYPERVISOR_NA=0,
    HYPERVISOR_XEN=1,
    HYPERVISOR_VMWARE=3,
    HYPERVISOR_HYPERV=4,
    HYPERVISOR_VMWARE_STANDALONE_HOST=5,

    DEFAULT_XEN_VIEW=6,
    DEFAULT_VMWARE_VIEW=3,
    DEFAULT_HYPERV_VIEW=10,

    OVERRIDE_NEVER=0,
    OVERRIDE_ALWAYS=1,
    OVERRIDE_AFTER=2,

    ALERT_TYPE_UNKNOWN=0,
    ALERT_TYPE_OTHER=1,
    ALERT_TYPE_LICENSE_EXPIRED=2,
    ALERT_TYPE_LICENSE_INVALID=3,
    ALERT_TYPE_UPDATES_AVAILABLE=4,
    ALERT_TYPE_BDS_CREATE=5,
    ALERT_TYPE_BDS_CONNECTIVITY=6,
    ALERT_TYPE_BDS_LOW_SPACE=7,
    ALERT_TYPE_VBA_CONNECTIVITY=8,
    ALERT_TYPE_BACKUP_WINDOW=9,
    ALERT_TYPE_BACKUP_NO_CBT=10,
    ALERT_TYPE_BACKUP_FULL=11,
    ALERT_TYPE_HYPERVISOR_SNAPSHOT=12,
    ALERT_TYPE_HYPERVISOR_LOGIN=13,
    ALERT_TYPE_UNPROTECTED_VM=14,
    ALERT_TYPE_FLR=15,
    ALERT_TYPE_INVENTORY_SYNC=16,
    ALERT_TYPE_UPDATE_COMPLETE=17,
    ALERT_TYPE_IR=18,
    ALERT_TYPE_LINK=19,
    ALERT_TYPE_EMAIL_ERROR=101,
    ALERT_TYPE_SMTP_NOT_CONFIGURED=102,

    // lmc - backup "types"
    BACKUP_MODE_VIRTUAL_FULL=1,
    BACKUP_MODE_FULL_AND_INC=2,
    BACKUP_MODE_FULL_AND_INC_FULL=3,

    // lmc - retention settings
    ARCHIVE_RETENTION_TYPICAL=1,
    ARCHIVE_RETENTION_KEEP_ALL=2,
    ARCHIVE_RETENTION_CUSTOM=3,

    // lmc - storage status
    CONN_STATUS_UNKNOWN=0,
    CONN_STATUS_OFF=1,
    CONN_STATUS_CANNOT_CONNECT=-1,
    CONN_STATUS_ON=2,

    // lmc - storage types
    STORAGE_TYPE_DEV=1,
    STORAGE_TYPE_LVM=2,
    STORAGE_TYPE_NFS=16,
    STORAGE_TYPE_CIFS=32,
    STORAGE_TYPE_ISCSI=64,
    STORAGE_TYPE_S3=128,
    STORAGE_TYPE_GS=256,
    STORAGE_TYPE_SWIFT=512,

    STORAGE_TYPE_STR_ATTACHED = "attached",
    STORAGE_TYPE_STR_NFS = "nfs",
    STORAGE_TYPE_STR_CIFS = "cifs",

    // lmc - storage usage
    BDS_TYPE_BACKUP=1,
    BDS_TYPE_REPLICATION=2,
    BDS_TYPE_CLOUD_CACHE=4,
    BDS_TYPE_IR_CACHE=8,
    BDS_TYPE_ARCHIVE=16,
    BDS_TYPE_SYNC=32,

    // lmc - encryption for the storage (Backup Data Store)
    /*BDS_ENCRYPT_NONE=0,
    BDS_ENCRYPT_CIPHER_AES_16=1,
    BDS_ENCRYPT_CIPHER_AES_32=2,
    BDS_ENCRYPT_CIPHER_AES_24=3,
    BDS_ENCRYPT_CIPHER_DES3_EDE_24=4,
    BDS_ENCRYPT_CIPHER_CAST6_16=5,
    BDS_ENCRYPT_CIPHER_CAST6_32=6,
    BDS_ENCRYPT_CIPHER_CAST5_16=7,
    */

    BDS_TYPE_STR_ARCHIVE = "archive",
    BDS_TYPE_STR_SYNC = "sync",
    BDS_TYPE_STR_BACKUP = "backup",

    // lmc - RESTlike calls to the server
    AJAX_ID_GLOBAL=0,
    AJAX_ID_NON_EXISTENT=-1,

    AJAX_INDEX_ID = "id",
    AJAX_INDEX_TYPE = "type",
    AJAX_INDEX_MESSAGE = "message",
    AJAX_INDEX_RESULT = "code",

    AJAX_TYPE_LICENSING = "licensing",
    AJAX_TYPE_RESTORE_DIALOG_NEW = "restore\u002Ddialog\u002Dnew",
    AJAX_TYPE_USER = "user",
    AJAX_TYPE_REPLICATION_DIALOG_NEW = "replication\u002Ddialog\u002Dnew",
    AJAX_TYPE_VM_SETTINGS = "inventory\u002Dsettings",
    AJAX_TYPE_REPLICATION_DIALOG_EDIT = "replication\u002Ddialog\u002Dedit",
    AJAX_TYPE_FLR_DIALOG_NEW = "flr\u002Ddialog\u002Dnew",
    AJAX_TYPE_INSTANT_VM = "instant\u002Dvm",
    AJAX_TYPE_ARCHIVE_DIALOG_EDIT = "archive\u002Ddialog\u002Dedit",
    AJAX_TYPE_CONFIG = "config",
    AJAX_TYPE_SESSION = "session",
    AJAX_TYPE_BACKUP = "backup",
    AJAX_TYPE_OPERATIONS = "operations",
    AJAX_TYPE_BACKUP_DIALOG_EDIT = "backup\u002Ddialog\u002Dedit",
    AJAX_TYPE_REPORT = "report",
    AJAX_TYPE_REPLICA = "replica",
    AJAX_TYPE_BACKUP_DIALOG_NEW = "backup\u002Ddialog\u002Dnew",
    AJAX_TYPE_ARCHIVE_DIALOG_NEW = "archive\u002Ddialog\u002Dnew",
    AJAX_TYPE_RESTORE_DIALOG_EDIT = "restore\u002Ddialog\u002Dedit",
    AJAX_TYPE_JOBORDER = "joborder",
    AJAX_TYPE_JOB = "job",
    AJAX_TYPE_ARCHIVE_BACKUP_DIALOG_NEW = "archive\u002Dbackup\u002Ddialog\u002Dnew",
    AJAX_TYPE_FLR_DELETE = "flr\u002Ddelete",
    AJAX_TYPE_DESTINATION_DIALOG = "destination\u002Ddialog",
    AJAX_TYPE_VM_SETTINGS_EDIT = "inventory\u002Dsettings\u002Dedit",

    FALSE=0,
    TRUE=1,

    REPLICA_SOURCE_TYPE_BACKUP=0,
    REPLICA_SOURCE_TYPE_VM=1,

    /*REPLICA_STATE_STANDBY=0,
    REPLICA_STATE_FAILOVER=2,
    REPLICA_STATE_INCOMPLETE=4,
    REPLICA_STATE_TESTING=1,
    REPLICA_STATE_REPLICATING=3,
    REPLICA_STATE_TESTING_PENDING=5,
    REPLICA_STATE_FAILOVER_PENDING=6,
    */

    CURRENT_STATE_ACTIVE=1,
    CURRENT_STATE_DELETING=3,
    CURRENT_STATE_PENDING=2,
    CURRENT_STATE_DELETED=0,

    // lmc - log level definitions
    LOG_LEVEL_EMERGENCY=0,
    LOG_LEVEL_ALERT=1,
    LOG_LEVEL_CRITICAL=2,
    LOG_LEVEL_ERROR=3,
    LOG_LEVEL_WARNING=4,
    LOG_LEVEL_NOTICE=5,
    LOG_LEVEL_INFO=6,
    LOG_LEVEL_DEBUG=7,

    // lmc - inventory tree types
    INV_TYPE_NONE=-1,
    INV_TYPE_DISK=1,
    INV_TYPE_VM=2,
    INV_TYPE_FOLDER=3,
    INV_TYPE_RESOURCE_POOL=4,
    INV_TYPE_HOST=5,
    INV_TYPE_DATACENTER=6,
    INV_TYPE_ENVIRONMENT=7,
    INV_TYPE_UNIVERSE=8,
    INV_TYPE_CLUSTER=9,
    INV_TYPE_VM_TEMPLATE_FOLDER=10,
    INV_TYPE_TAG=11,
    INV_TYPE_TEMPLATE=12,
    INV_TYPE_VAPP=13,
    INV_TYPE_FOLDER_ROOT=14,
    INV_TYPE_TAG_ROOT=15,
    INV_TYPE_XEN_POOL=16,
    INV_TYPE_COMPUTE_RESOURCE=17,
    INV_TYPE_VAPP_ROOT=18,
    INV_TYPE_CDROM=19,
    INV_TYPE_NIC=20,
    INV_TYPE_USB=21,
    INV_TYPE_SNAP=22,
    INV_TYPE_DATASTORE=23,
    INV_TYPE_JOB=24,
    INV_TYPE_DISCOVERED_VMS=25,
    INV_TYPE_GENERIC=99,


    // lmc - REST API return codes
    AJAX_RESULT_SUCCESS=0,
    AJAX_RESULT_PARTIAL_SUCCESS=3,
    AJAX_RESULT_WARNING=1,
    AJAX_RESULT_UNAUTHENTICATED=-1,
    AJAX_RESULT_ERROR=2,

    // lmc - verify types
    VERIFY_TYPE_NONE=1,
    VERIFY_TYPE_QUICK=2,
    VERIFY_TYPE_FULL=3,

    // lmc - presentation layer - job manager tab IDs
    JOB_TAB_ACTIVE=0,
    JOB_TAB_MANAGER=1,
    JOB_TAB_HISTORY=2,
    JOB_TAB_SYSTEM=3,

    // lmc - instant recovery state
    INSTANT_VM_STATE_UNKNOWN=0,
    INSTANT_VM_STATE_CREATING=1,
    INSTANT_VM_STATE_ACTIVE=2,
    INSTANT_VM_STATE_SEEDING=3,
    INSTANT_VM_STATE_READY=4,
    INSTANT_VM_STATE_COMPLETING=5,
    INSTANT_VM_STATE_COMPLETED=6,
    INSTANT_VM_STATE_ENDING=7,
    INSTANT_VM_STATE_ENDED=8,
    INSTANT_VM_STATE_ERROR=9,

    SAVE_STATE_PRESENTATION=0,
    SAVE_STATE_MANAGEMENT=1,
    SAVE_STATE_ENGINE=2,
    SAVE_STATE_FINISHED=3,

    SAVE_STATUS_ERRORS=3,
    SAVE_STATUS_PENDING=0,
    SAVE_STATUS_SAVED=1,
    SAVE_STATUS_DELETED=4,
    SAVE_STATUS_SAVED_ERRORS=2,

    EMAIL_ENCRYPTION_NONE=0,
    EMAIL_ENCRYPTION_TLS=1,
    EMAIL_ENCRYPTION_SSL=2,

    // lmc - presentation layer  - dashboard refresh in ms
    DEFAULT_JOBS_REFRESH=5000,
    DEFAULT_STORAGE_REFRESH=5000,
    DEFAULT_ALERT_REFRESH=5000,
    DEFAULT_RESTORE_REFRESH=5000,
    DEFAULT_ACTIVE_JOB_REFRESH=5000,
    DEFAULT_REPLICATION_REFRESH=5000,
    DEFAULT_BACKUP_REFRESH=5000,

    // lmc - presentation layer - widget identifiers
    BACKUP_REFRESH=0,
    REPLICATION_REFRESH=1,
    RESTORE_REFRESH=2,
    ALERT_REFRESH=3,
    ACTIVE_JOB_REFRESH=4,
    STORAGE_REFRESH=5,
    JOBS_REFRESH=6,

    UPDATE_STATUS_UNKNOWN=0,
    UPDATE_STATUS_AVAILABLE=1,
    UPDATE_STATUS_PENDING=2,
    UPDATE_STATUS_UPDATING=3,
    UPDATE_STATUS_COMPLETED=4,
    UPDATE_STATUS_FAILED=5,

    FLR_TYPE_CIFS=0,
    FLR_TYPE_ISCSI=1,

    MODE_SUBTYPE_FULL=0,
    MODE_SUBTYPE_INC=1,

    BACKUP_CATALOG_RECOVERY_DIALOG=2,
    BACKUP_CATALOG_ROLLBACK_DIALOG=3,
    BACKUP_CATALOG_TAB=0,
    BACKUP_CATALOG_VIEW_DATE=1,
    BACKUP_CATALOG_FLR_DIALOG=1,
    BACKUP_CATALOG_VIEW_BDS=3,
    BACKUP_CATALOG_VIEW_APPLIANCE = 4,

    BACKUP_CATALOG_VIEW_VM=0,
    BACKUP_CATALOG_VIEW_ROLLBACK=2,

    BACKUP_STATUS_SUCCESS = 0,
    BACKUP_STATUS_WARNING = 1,
    BACKUP_STATUS_FAILURE = 2,

    CREDENTIAL_TYPE_NONE=0,
    CREDENTIAL_TYPE_FILE_REC_CREDS=1,
    CREDENTIAL_TYPE_FROM_CONFIG=2,
    CREDENTIAL_TYPE_SYS_GEN=3,
    CREDENTIAL_TYPE_CUSTOM=4,

    // lmc - update logs to support
    /*SUPPORTFILE_TYPE_DOWNLOAD=1,
    SUPPORTFILE_TYPE_SEND=2,
    SUPPORTFILE_TYPE_SCHEDULED=3,
    SUPPORTFILE_TYPE_RETRY=4,

    SUPPORTFILE_SEND_STATUS_REQUESTED=0,
    SUPPORTFILE_SEND_STATUS_SENT=1,
    SUPPORTFILE_SEND_STATUS_UPLOAD_FAILED=2,
    SUPPORTFILE_SEND_STATUS_GENERATION_FAILED=3,

    SUPPORTFILE_STATUS_REQUESTED=0,
    SUPPORTFILE_STATUS_READY=1,
    SUPPORTFILE_STATUS_FAILED=2,
    SUPPORTFILE_STATUS_DELETING=3,
    SUPPORTFILE_STATUS_DELETED=4,*/

    LICENSING_UNLIMITED_SOCKETS=-1,

    SYNC_STATUS_PENDING=0,
    SYNC_STATUS_ACTIVE=1,
    SYNC_STATUS_ERROR=2,

    SCHEDULE_RUN_EVERY=0,
    SCHEDULE_RUN_FIRST=1,
    SCHEDULE_RUN_SECOND=2,
    SCHEDULE_RUN_THIRD=3,

    PROTECT_SETTINGS=1,

    SCHEDULE_TYPE_SCHEDULED=4,
    SCHEDULE_TYPE_NOW=1,
    //SCHEDULE_TYPE_RUN_ONCE=2,
    //SCHEDULE_TYPE_ON_DEMAND=3,

    VERSION_UP_TO_DATE=0,
    VERSION_UPDATE_IN_PROGRESS=2,
    VERSION_NOT_UP_TO_DATE=1,

    LOCATION_OR_TARGET_TARGET=2,
    LOCATION_OR_TARGET_LOCATION=1,

    INCLUDE_NEW_HW_NONE=0,
    INCLUDE_NEW_HW_ALL=1,
    INCLUDE_NEW_HW_DISKS_ONLY=2,
    INCLUDE_NEW_HW_VM_SETTINGS_ONLY=3,

    // lmc - quiesce VM on backup
    QUIESCE_YES=1,
    QUIESCE_NO=0,

    RETENTION_KEEP_ALL=2,
    RETENTION_TYPICAL=1,

    PRIORITY_LOW=0,
    PRIORITY_MEDIUM=50,
    PRIORITY_HIGH=100,

    // lmc - presentation - report type to generate
    REPORT_TYPE_HTML=1,
    REPORT_TYPE_CSV=2,
    REPORT_TYPE_PDF=3,

    // lmc - presentation - tour/quickstart only
    ENABLE_TOUR=7,

    PROTECT_STATUS=0,

    ERR_INVENTORY = "Select at least one inventory item.",

    //LOGIN_URL = "/api/login/",

    NETWORK_TYPE_DHCP = "dhcp",
    NETWORK_TYPE_STATIC = "static",

    BLANK_LISTBOX_TEXT = "\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D",

    //ERR_INVALID_UPDATE_FILENAME = "Invalid filename. The filename should be in this format: phdvb\u002D7.0.1.9083.phd",
    ERR_WEEKLY_RUN_DAY = "Select at least one day for the job to run.",
    ERR_START_DATE_GT_END_DATE = "The \u0027From\u0027 date cannot be after the \u0027To\u0027 date",

    KNOWLEDGE_BASE_URL = "http://support.unitrends.com/ikm/",
    CE_KNOWLEDGE_BASE_URL = "https://unitrends-support.force.com/UnitrendsFree";
    DOCUMENTATION_URL = "http://www.unitrends.com/documents/administrators-guide/",
    CE_DOCUMENTATION_URL = "http://www.unitrends.com/docs/user-guides/unitrends-free-administrators-guide",

    DEFAULT_START_TIME = "20:00:00",
    DEFAULT_END_TIME = "04:00:00",
    DEFAULT_DO_NOT_RUN_AFTER_TIME = "23:59:00",
    DEFAULT_EMAIL_PORT = "25",
    DEFAULT_TIMEZONE = "US/Eastern",

    EMPTY_CELL_TEXT = "\u002D\u002D",
    RETENTION_VIRTUAL_FILL_SINGULAR = "Assuming one year of daily backups, these settings will keep %s Virtual Full backup per VM.",
    RETENTION_FULL_INC = "Assuming Fulls are scheduled weekly, these settings will keep %s Full and %s Incremental backups.",
    RETENTION_VIRTUAL_FILL_PLURAL = "Assuming one year of daily backups, these settings will keep %s Virtual Full backups per VM.",

    //STATIC_URL = "/static/";
	//lmc
    STATIC_URL = "assets/";

// Application IDs.
var APP_ID_FILE_LEVEL = 1,
    APP_ID_EXCHANGE_2003 = 2,
    APP_ID_EXCHANGE_2007 = 3,
    APP_ID_SQL_SERVER_2012 = 24,
    APP_ID_ARCHIVE = 30,
    APP_ID_VMWARE = 40,
    APP_ID_HYPERV_2012 = 51,
    APP_ID_ORACLE_11 = 100;

var ALERT_HELP_LINKS = {

    0:"21803964",
    1:"21803964",
    2:"21803964",
    3:"21803964",
    4:"21898139",
    5:"26127905",
    6:"21898149",
    7:"25342025",
    8:"26201924",
    9:"21898159",
    10:"22391340",
    11:"22391350",
    12:"22217785",
    13:"21898199",
    14:"22391370",
    15:"22346465",
    16:"22501479",
    17:"21898139",
    18:"26374555",
    19:"28207810",
    101:"21927514",
    102:"21927504"

};

// lmc - added for UEB
var ALERT_SEVERITY_NOTICE = "notice";
var ALERT_SEVERITY_WARNING = "warning";
var ALERT_SEVERITY_CRITICAL = "critical";

// lmc - added for UEB
var API_DIR = "/api";

//mmb - added for link to forums
var FEEDBACK_URL = "https://unitrends-support.force.com/UnitrendsFree/s";
