(function($, undefined) {
    
    var $btnPrint = $("#eula-print"),
        $btnClose = $("#eula-close");


    function closePrint() {
        document.body.removeChild(this.__container__);
    }

    function initPrint() {
        this.contentWindow.__container__ = this;
        this.contentWindow.onbeforeunload = closePrint;
        this.contentWindow.onafterprint = closePrint;
        this.contentWindow.print();
    }

    function printPage(url) {
        var printFrame = document.createElement("iframe");
        printFrame.onload = initPrint;
        printFrame.style.visibility = "hidden";
        printFrame.style.position = "fixed";
        printFrame.style.right = "0";
        printFrame.style.bottom = "0";
        printFrame.src = url;
        document.body.appendChild(printFrame);
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        $btnPrint.on("click", function() {
            printPage("/eula/?print=1");
        });

        $btnClose.on("click", function() {
            window.close();
        });

    });

})(jQuery);
