(function($, PHD, window, undefined) {

    var $edit = $(".btn-edit-account");

    $edit.on("click", function(event) {
        event.preventDefault();
        PHD.wizard('/accounts/edit/', "edit-account", {
            title: gettext("Edit Account Details"),
            dialogClass: "dialog-edit-account dialog-modal-form",
            helpArticle: PHD.App.getHelpLink("account", true),
            width: 400,
            height: 500
        });
    });

    $(document).on("accountedit", handleAccountEdit);

    function handleAccountEdit(event, data) {
        data.forEach(function(item) {
            $("#" + item.name).html(item.value);
        });
    }

})(jQuery, window.PHD || (window.PHD = {}), window);
